      SUBROUTINE seatad(Muladd,Ny,Nfcst)
      IMPLICIT NONE
C-----------------------------------------------------------------------
c     Make adjustments or set seasonal adjustment component variables
c     generated by the SEATS signal extraction routines
c     Created by Brian Monsell October 2005
C-----------------------------------------------------------------------
      INCLUDE 'srslen.prm'
*      INCLUDE 'lzero.cmn'
*      INCLUDE 'priadj.cmn'
*      INCLUDE 'priusr.cmn'
      INCLUDE 'seatcm.cmn'
c      INCLUDE 'seatmd.cmn'
      INCLUDE 'seatlg.cmn'
      INCLUDE 'x11ptr.cmn'
      INCLUDE 'x11adj.cmn'
      INCLUDE 'x11fac.cmn'
C-----------------------------------------------------------------------
      INTEGER Muladd,Ny,Nfcst,i,i2,nlast
C-----------------------------------------------------------------------
      nlast=Posffc
c      IF(Nfcst.gt.3*Ny)nlast=nlast-(Nfcst-3*Ny)
C-----------------------------------------------------------------------
      IF(Muladd.ne.1)THEN
       DO i=Pos1bk,nlast
        IF(Havesf)Seatsf(i)=Seatsf(i)/100D0
        IF(Haveir)Seatir(i)=Seatir(i)/100D0
        IF(Haveaf)Seataf(i)=Seataf(i)/100D0
        IF(Havecy)Seatcy(i)=Seatcy(i)/100D0
       END DO
      END IF
C-----------------------------------------------------------------------
c  append seasonal forecasts to seasonal component, if it exists.
c  also combine seasonal component with seasonal regression factors.
C-----------------------------------------------------------------------
      IF(Havesf)THEN
       IF(Havfsf)THEN
        DO i=Posfob+1,nlast
         Seatsf(i)=Setfsf(i-Posfob)
         IF(Muladd.ne.1)Seatsf(i)=Seatsf(i)/100D0
        END DO
       END IF
       IF(Adjsea.eq.1)CALL addmul(Seatsf,Facsea,Seatsf,Pos1bk,Posffc)
      END IF
C-----------------------------------------------------------------------
c  append forecasts of adjusted series to seasonally adjusted series,
c  if it exists.
c  also remove seasonal component from final seasonally adjusted data.
C-----------------------------------------------------------------------
      IF(Havesa)THEN
       IF(Havfsa)THEN
        DO i=Posfob+1,nlast
         Seatsa(i)=Setfsa(i-Posfob)
        END DO
       END IF
       IF(Adjsea.eq.1)CALL divsub(Seatsa,Seatsa,Facsea,Pos1bk,Posffc)
C-----------------------------------------------------------------------
c  if there are temporary prior adjustments, add these back to the
c  seasonally adjusted series
*C-----------------------------------------------------------------------
*       IF(Nustad.gt.0)THEN
*        DO i=Pos1bk,Posffc
*         i2=Frstat+i-Pos1bk+Lsp-1
*         IF(Muladd.eq.1)THEN
*          Seatsa(i)=Seatsa(i)+Usrtad(i2)
*         ELSE
*          Seatsa(i)=Seatsa(i)*Usrtad(i2)
*         END IF
*        END DO
*       END IF
C-----------------------------------------------------------------------
*       IF(Finao.and.Nao.gt.0)
*     &    CALL divsub(Seatsa,Seatsa,Facao,Pos1bk,Posffc)
*       IF(Finls.and.Nls.gt.0)
*     &    CALL divsub(Seatsa,Seatsa,Facls,Pos1bk,Posffc)
*       IF(Fintc.and.Ntc.gt.0)
*     &    CALL divsub(Seatsa,Seatsa,Factc,Pos1bk,Posffc)
*       IF(Finusr)
*     &    CALL divsub(Seatsa,Seatsa,Facusr,Pos1bk,Posffc)
      END IF
C-----------------------------------------------------------------------
c  append forecasts of trend to the trend component, if it exists.
C-----------------------------------------------------------------------
      IF(Havetr)THEN
       IF(Havftr)THEN
        DO i=Posfob+1,nlast
         Seattr(i)=Setftr(i-Posfob)
        END DO
       END IF      
      END IF
C-----------------------------------------------------------------------
c  append forecasts of irregular to the irregular component,
c  if it exists.
C-----------------------------------------------------------------------
      IF(Haveir)THEN
       IF(Havfir)THEN
        DO i=Posfob+1,nlast
         Seatir(i)=Setfir(i-Posfob)
         IF(Muladd.ne.1)Seatir(i)=Seatir(i)/100D0
        END DO
       END IF
      END IF
C-----------------------------------------------------------------------
c  append forecasts of transitory to the transitory component,
c  if it exists.
C-----------------------------------------------------------------------
      IF(Havecy)THEN
       IF(Havfcy)THEN
        DO i=Posfob+1,nlast
         Seatcy(i)=Setfcy(i-Posfob)
         IF(Muladd.ne.1)Seatcy(i)=Seatcy(i)/100D0
        END DO
       END IF
      END IF
C-----------------------------------------------------------------------
c  combine adjustment factors with seasonal regression factors.
C-----------------------------------------------------------------------
      IF(Haveaf)THEN
       IF(Adjsea.eq.1)CALL addmul(Seataf,Facsea,Seataf,Pos1bk,nlast)
      END IF
C-----------------------------------------------------------------------
      RETURN
      END
